#ifndef _Hashtable_h
#define _Hashtable_h



#include "Types.h"

class Object;
class HashCons;



class Hashtable
{
public:

	virtual bool isEmpty();
	virtual ulong size();

	virtual Object* item(ulong);
	virtual bool insert(ulong, Object*);
	virtual bool remove(ulong);
	virtual bool contains(ulong);
		
	Hashtable(ulong);
	virtual ~Hashtable();

private:

	virtual Object* start(ulong&, ulong&);
	virtual Object* item(ulong, ulong);
	virtual void remove(ulong, ulong);
	virtual void advance(ulong&, ulong&);

	virtual ulong getIndex(ulong);
	virtual ulong findTableSize(ulong);

	void rehash();
	void rehashTest();
	void rehashInsert(HashCons*);

	ulong tableSize;
	ulong numberOfEntries;
	ulong numberOfLists;

	HashCons** table;

};



#endif


