#ifndef _Money_h
#define _Money_h



#include "Value.h"
#include "String.h"
#include "Amount.h"
#include "Currency.h"



class Money : public Value
{
public:
	virtual void acceptReader(Reader*);
	virtual void acceptWriter(Writer*) const;
	virtual const char* typeName() const;

	virtual const String asString() const;
	virtual bool isValid() const;
	virtual bool operator==(const Money&);
	
	virtual Money& operator=(const Money&);
	virtual Money& operator+=(const Money&);
	virtual Money& operator+=(const Amount&);
	virtual Money& operator-=(const Money&);
	virtual Money& operator-=(const Amount&);
	
	Money();
	Money(Money&);
	Money(Amount&, Currency&);
	
private:
	Amount amount;
	Currency currency;

};



#endif

