#ifndef _String_h
#define _String_h



#include "Types.h"



class String
{
public:
	
		// stringaccess
	virtual String word			( int = 1 ) const;
	virtual String mid			( int, int ) const;
	virtual String left			( int ) const;
	virtual String right		( int ) const;
	
	virtual int length			( ) const;
	virtual int strlen			( ) const;
	
	virtual int asInt			( ) const;
	virtual long asLong			( ) const;
	virtual char* charPtr		( ) const;
	virtual ulong hash			( ) const;
	
	virtual char operator[]		( int ) const;
	virtual String operator()	( int ) const;
	
	virtual bool operator==		( const String& ) const;
	virtual bool operator==		( const char* ) const;
	virtual bool operator!=		( const String& ) const;
	virtual bool operator!=		( const char* ) const;
	
		// stringmanipulation
	virtual void fromInt		( int );
	virtual void fromLong		( long );
	virtual void fromFloat		( float );
	virtual void fromDouble		( double );

	
	virtual String& operator=	( const String& );
	virtual String& operator=	( const char* );
	virtual String& operator+=	( const String& );
	virtual String& operator+=	( const char* );
	
	friend String operator+		( String&, String& );
	friend String operator+		( String&, char* );
	friend String operator+		( char*, String& );

		// ctor and dtor
	String						( const String& );
	String						( const char* );
	String						( char );
	String						( long );
	String						( double );
	String						( );
	virtual ~String				( );
	protected:

		// simple string conventions
	virtual bool isSpace		( char ) const;
	
		// implementation
	char*						s;
};



#endif

